
pipeline {
    options {
        buildDiscarder(logRotator(numToKeepStr: '10')) // Retain history on the last 10 builds
        timestamps() // Append timestamps to each line
        timeout(time: 40, unit: 'SECONDS') // Set a timeout on the total execution time of the job
    }
    agent any
environment {
  PATH = "/usr/local/bin:$PATH"
}
    stages {
        stage('Checkout project') {
            steps {
                script {
                    git branch: "main",
                        credentialsId: 'GitLabOpen',
                        url: 'https://gitlab.com/balu.intell/ola.git'
                }
            }
        }
        stage('Installing packages') {
            steps {
                script {
                    sh 'pip3 install -r requirements.txt'
                }
            }
        }
        stage('Linting/Static Code Checking') { // Run pylint against your code
            steps {
                script {
                sh """
                pylint **/*.py
                """
                }
            }
    }
    stage('Running Unit tests') {
            steps {
                script {
                    sh 'pytest --junitxml results.xml test/*.py'
                }
            }
        }
    }
}
